## noweb 2.13

=== Makefile ===
# Copyright 1995-2023 by Norman Ramsey.  All rights reserved.
# See file COPYRIGHT for more information.
#
# Don't edit this file; you should be editing the Makefiles in the
# src and contrib directories.

VERSION=2.13
SHELL=/bin/sh
CINAME=-Nv`echo $(VERSION) | tr . _`
CIMSG=-f -m'standard checkin preparing to export version $(VERSION)'

all:
	@echo "You have no business running 'make' here; please look at the README file"
	@exit 1
source:
	for i in src; do (cd $$i && $(MAKE) $@); done
www:
	for i in src/xdoc examples; do (cd $$i && $(MAKE) $@); done

clean:
	for i in src examples contrib; do (cd $$i && $(MAKE) $@); done
	rm -f nwsrcfilter *~ */*~
clobber: clean
	for i in src examples contrib; do (cd $$i && $(MAKE) $@); done

DATE:
	(./echo -n "Version $(VERSION) of "; date) > $@

versioncheck:
	@if [ -z "$(UPPERVERSION)" ]; then echo "run 'make versioncheck' in the parent directory, not here" 1>&2; exit 1; fi
	@if [ "$(VERSION)" = "$(UPPERVERSION)" ]; then echo "Version $(VERSION) OK in Makefile"; else echo "Version mismatch in Makefile: upper $(UPPERVERSION) lower $(VERSION)"; exit 1; fi
	@if [ "$(VERSION)" = "`awk '{print $$2}' DATE`" ]; then echo "Version $(VERSION) OK in DATE"; else ./echo -n "Version mismatch in DATE: "; cat DATE; exit 1; fi
	@if fgrep -s "This is version $(VERSION) of " README; then echo "Version $(VERSION) OK in README"; else echo "Version mismatch in README"; exit 1; fi
	@if fgrep -s "CHANGES FOR VERSION $(VERSION)" CHANGES; then echo "Version $(VERSION) OK in CHANGES"; else echo "Version mismatch in CHANGES"; exit 1; fi
	@if fgrep -s " for version $(VERSION) of" src/README; then echo "Version $(VERSION) OK in src/README"; else echo "Version mismatch in src/README"; exit 1; fi
	@if fgrep -s "version $(VERSION)" src/xdoc/notangle.txt; then echo "Version $(VERSION) OK in src/xdoc/notangle.txt"; else echo "Version mismatch in src/xdoc/notangle.txt"; exit 1; fi

nwsrcfilter: nwsrcfilter.icn
	icont $@

tarnames: clean source nwsrcfilter DATE
	find . -not -type d -not -name FAQ.old -print | ./nwsrcfilter

tar: clean source nwsrcfilter DATE emacscheck
	chmod +w src/Makefile
	rm -rf /tmp/noweb-$(VERSION)
	mkdir -p /tmp/noweb-$(VERSION)
	tar cvf - `find . ! -type d -not -name FAQ.old -print | ./nwsrcfilter` | (cd /tmp/noweb-$(VERSION) && tar xf - )
	(cd /tmp && tar cf - noweb-$(VERSION) ) | gzip -v > ../noweb-$(VERSION).tgz
	rm -f ../noweb.tgz
	(cd .. && ln -s noweb-$(VERSION).tgz noweb.tgz)
	chmod -w src/Makefile

ctan: clean source nwsrcfilter DATE emacscheck
	chmod +w src/Makefile
	(cd src && $(MAKE) boot)
	rm -f ../noweb-$(VERSION)-ctan.zip
	find ./* ! -type d -not -name FAQ.old -not -name '.git*' -print | ./nwsrcfilter | sed 's@^@noweb/@' | ( ln -s . noweb; zip ../noweb-$(VERSION)-ctan.zip -@; rm -f noweb )
	chmod -w src/Makefile

emacscheck:
	-echo "Checking to ensure distribution matches personal emacs mode" 1>&2
	diff src/elisp/noweb-mode.el $(HOME)/emacs/noweb-mode.el

=== contrib/Makefile ===
SHELL=/bin/sh
LIB=/dev/null  # to be overridden
DIRS=davelove jonkrom leew norman

# don't do kostas; it requires gnu make (ugh)

all:
	for i in $(DIRS); do (cd $$i && $(MAKE) $@); done
install:
	for i in $(DIRS); do (cd $$i && $(MAKE) LIB=$(LIB) $@); done
source:
	for i in $(DIRS); do (cd $$i && $(MAKE) $@); done
clean:
	for i in $(DIRS); do (cd $$i && $(MAKE) $@); done
clobber: clean

=== examples/Makefile ===
WWW=$(HOME)/www/noweb/examples
SHELL=/bin/sh
NOTANGLE=nountangle -m3
NOWEAVE=noweave

.SUFFIXES: .i3 .m3 .nw .tex .dvi .html
.nw.html:
	$(NOWEAVE) -filter l2h -filter btdefn -index -html $< > $@
.nw.tex:
	$(NOWEAVE) -index -filter btdefn $< > $@
.nw.i3:
	$(NOTANGLE) -Rinterface -L'<* LINE %L "%F" *>%N' $< > $@
.nw.m3:
	$(NOTANGLE) -L'<* LINE %L "%F" *>%N' $< > $@
.tex.dvi:
	latex '\scrollmode \input '"$*"; while grep -s 'Rerun to get cross-references right' $*.log; do latex '\scrollmode \input '"$*"; done

HTML=breakmodel.html compress.html dag.html graphs.html mipscoder.html primes.html \
	scanner.html test.html tree.html wc.html wcni.html


www: $(HTML)
	copy -v $(HTML) $(WWW)
	copy -v README.h $(WWW)/index.html

clean:
	rm -f *~ *.aux *.tex *.dvi *.log *.html *.toc

clobber: clean

compress.html: compress.nw
	$(NOWEAVE) -filter l2h -index -autodefs c -html compress.nw > $@
compress.tex: compress.nw
	$(NOWEAVE) -index -autodefs c compress.nw > $@
dag.html: dag.nw
	$(NOWEAVE) -filter l2h -index -autodefs icon -html dag.nw > $@
dag.tex: dag.nw
	$(NOWEAVE) -index -autodefs icon dag.nw > $@
mipscoder.html: mipscoder.nw
	$(NOWEAVE) -filter l2h -index -autodefs sml -html mipscoder.nw > $@
mipscoder.tex: mipscoder.nw
	$(NOWEAVE) -autodefs sml -index mipscoder.nw > $@
scanner.html: scanner.nw
	$(NOWEAVE) -filter l2h -index -autodefs c -autodefs yacc -html scanner.nw > $@
scanner.tex: scanner.nw
	$(NOWEAVE) -index -autodefs c -autodefs yacc scanner.nw > $@
tree.html: tree.nw
	$(NOWEAVE) -filter l2h -index -autodefs icon -html tree.nw > $@
tree.tex: tree.nw
	$(NOWEAVE) -index -autodefs icon tree.nw > $@
test.html: test.nw
	$(NOWEAVE) -filter l2h -html test.nw > $@
test.tex: test.nw
	$(NOWEAVE) test.nw > $@
wc.html: wc.nw2html
	$(NOWEAVE) -autodefs c -filter btdefn -index -html -n wc.nw2html > $@
wcni.html: wc.nw2html
	$(NOWEAVE) -filter btdefn -x     -html -n wc.nw2html > $@
wc.tex: wc.nw
	$(NOWEAVE) -autodefs c -filter btdefn -index wc.nw > $@

=== src/Makefile ===
# Copyright 1995-2018 by Norman Ramsey.  All rights reserved.
# See file COPYRIGHT for more information.
#
# Adjust these two lines for your ANSI C compiler
CC=gcc
CFLAGS=-ansi -pedantic -O -Wall -Werror
# If you have Icon, you should use the Icon versions of the noweb pipeline.
#LIBSRC=icon
LIBSRC=awk
# If you are lucky enough to have an Icon compiler icont, use ICONC=iconc
ICONC=icont
ICONT=icont
GITVERSION=`./gitversion`

# BIN is where the commands (notangle, noweave, nountangle, noroots) land
# LIB is where the pieces of the pipes (nt, markup, unmarkup) are stored
# MAN is the root of your local man pages directory
# MANEXT is the extension for your commands' man pages (usually 1 or l)
# MAN7EXT is the extension for the nowebstyle man page (usually 7)
# TEXINPUTS is the directory for TeX macro files
# ELISP is the directory for emacs lisp files, or /dev/null not to install
BIN=/usr/local/noweb
LIB=/usr/local/noweb/lib
MAN=/usr/local/noweb/man
MANEXT=1
MAN7EXT=7
TEXINPUTS=/usr/local/tex/inputs
ELISP=/dev/null

# change WEAVE if you want a different version of noweave to be installed
WEAVE=noweave

# Stop editing.  No user-serviceable parts below.
SHELL=/bin/sh
CINAME=
CIMSG=
MANDIR=$(MAN)/man$(MANEXT)
MAN7DIR=$(MAN)/man$(MAN7EXT)
CATDIR=$(MAN)/cat$(MANEXT)
CAT7DIR=$(MAN)/cat$(MAN7EXT)
LIBNAME=$(LIB)
TEXNAME=$(TEXINPUTS)

all:
	(cd c && $(MAKE) "CC=$(CC)" "CFLAGS=$(CFLAGS)" $@)
	for i in shell lib xdoc tex; do (cd $$i && $(MAKE) $@); done
	(cd $(LIBSRC) && $(MAKE) "ICONT=$(ICONT)" "ICONC=$(ICONC)" $@)

FAQ: FAQ.html
	sleep 1; html2ascii FAQ.html > $@

FAQ.html: $(HOME)/www/noweb/FAQ.html
	rm -f $@
	cp $(HOME)/www/noweb/FAQ.html $@
	chmod -w $@

install: install-code install-man install-tex install-elisp
uninstall: uninstall-code uninstall-man uninstall-tex uninstall-elisp
	rmdir $(BIN) $(LIB) 2>/dev/null || true

install-shell:
	mkdir -p $(BIN) $(LIB)
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/noweb > $(BIN)/noweb
	chmod +x $(BIN)/noweb
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/notangle > $(BIN)/notangle
	chmod +x $(BIN)/notangle
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/$(WEAVE) > $(BIN)/$(WEAVE)
	chmod +x $(BIN)/$(WEAVE)
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/nountangle > $(BIN)/nountangle
	chmod +x $(BIN)/nountangle
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/nodefs > $(BIN)/nodefs
	chmod +x $(BIN)/nodefs
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/noroots > $(BIN)/noroots
	chmod +x $(BIN)/noroots
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/nuweb2noweb > $(BIN)/nuweb2noweb
	chmod +x $(BIN)/nuweb2noweb
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/cpif > $(BIN)/cpif
	chmod +x $(BIN)/cpif
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/htmltoc > $(BIN)/htmltoc
	chmod +x $(BIN)/htmltoc
	sed "s@|LIBDIR|@$(LIBNAME)@;s@|GITVERSION|@$(GITVERSION)@" shell/noroff > $(BIN)/noroff
	chmod +x $(BIN)/noroff
	sed "s@|LIBDIR|@$(LIBNAME)@" shell/toroff > $(LIB)/toroff
	chmod +x $(LIB)/toroff
	cp shell/tmac.w $(LIB)

uninstall-shell:
	rm -f $(BIN)/noweb
	rm -f $(BIN)/notangle
	rm -f $(BIN)/$(WEAVE)
	rm -f $(BIN)/nountangle
	rm -f $(BIN)/nodefs
	rm -f $(BIN)/noroots
	rm -f $(BIN)/nuweb2noweb
	rm -f $(BIN)/cpif
	rm -f $(BIN)/htmltoc
	rm -f $(BIN)/noroff
	rm -f $(LIB)/toroff
	rm -f $(LIB)/tmac.w

install-code: install-shell
	mkdir -p $(BIN) $(LIB)
	strip c/nt c/markup c/mnt c/finduses c/nwmktemp
	cp c/nt c/markup c/mnt c/finduses c/nwmktemp $(LIB)
	(cd $(LIBSRC) && $(MAKE) "ICONT=$(ICONT)" "ICONC=$(ICONC)" LIB=$(LIB) BIN=$(BIN) install)
	(cd lib && $(MAKE) LIB=$(LIB) install)

uninstall-code: uninstall-shell
	rm -f $(LIB)/nt $(LIB)/markup $(LIB)/mnt $(LIB)/finduses
	(cd $(LIBSRC) && $(MAKE) "ICONT=$(ICONT)" "ICONC=$(ICONC)" LIB=$(LIB) BIN=$(BIN) uninstall)
	(cd lib && $(MAKE) LIB=$(LIB) uninstall)
install-man:
	mkdir -p $(MANDIR) $(MAN7DIR)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/cpif.1 > $(MANDIR)/cpif.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nodefs.1 > $(MANDIR)/nodefs.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noroots.1 > $(MANDIR)/noroots.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noweb.1 > $(MANDIR)/noweb.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noindex.1 > $(MANDIR)/noindex.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nuweb2noweb.1 > $(MANDIR)/nuweb2noweb.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/notangle.1 > $(MANDIR)/notangle.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noroff.1 > $(MANDIR)/noroff.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/sl2h.1 > $(MANDIR)/sl2h.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/htmltoc.1 > $(MANDIR)/htmltoc.$(MANEXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nowebstyle.7 > $(MAN7DIR)/nowebstyle.$(MAN7EXT)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nowebfilters.7 > $(MAN7DIR)/nowebfilters.$(MAN7EXT)
	rm -f $(MANDIR)/noweave.$(MANEXT)
	(cd $(MANDIR) && ln notangle.$(MANEXT) noweave.$(MANEXT))
	rm -f $(MANDIR)/nountangle.$(MANEXT)
	(cd $(MANDIR) && ln notangle.$(MANEXT) nountangle.$(MANEXT))
uninstall-man:
	rm -f $(MANDIR)/cpif.$(MANEXT)
	rm -f $(MANDIR)/nodefs.$(MANEXT)
	rm -f $(MANDIR)/noroots.$(MANEXT)
	rm -f $(MANDIR)/noweb.$(MANEXT)
	rm -f $(MANDIR)/noindex.$(MANEXT)
	rm -f $(MANDIR)/nuweb2noweb.$(MANEXT)
	rm -f $(MANDIR)/notangle.$(MANEXT)
	rm -f $(MANDIR)/noroff.$(MANEXT)
	rm -f $(MANDIR)/sl2h.$(MANEXT)
	rm -f $(MANDIR)/htmltoc.$(MANEXT)
	rm -f $(MAN7DIR)/nowebstyle.$(MAN7EXT)
	rm -f $(MAN7DIR)/nowebfilters.$(MAN7EXT)
	rm -f $(MANDIR)/noweave.$(MANEXT)
	rm -f $(MANDIR)/nountangle.$(MANEXT)
	rmdir $(MANDIR) $(MAN7DIR) $(MAN) 2>/dev/null || true
install-gzipped-man:
	mkdir -p $(MANDIR) $(MAN7DIR)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/cpif.1  | gzip -9 > $(MANDIR)/cpif.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nodefs.1  | gzip -9 > $(MANDIR)/nodefs.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noroots.1  | gzip -9 > $(MANDIR)/noroots.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noweb.1  | gzip -9 > $(MANDIR)/noweb.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noindex.1  | gzip -9 > $(MANDIR)/noindex.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nuweb2noweb.1  | gzip -9 > $(MANDIR)/nuweb2noweb.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/notangle.1  | gzip -9 > $(MANDIR)/notangle.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noroff.1  | gzip -9 > $(MANDIR)/noroff.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/sl2h.1  | gzip -9 > $(MANDIR)/sl2h.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/htmltoc.1  | gzip -9 > $(MANDIR)/htmltoc.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nowebstyle.7  | gzip -9 > $(MAN7DIR)/nowebstyle.$(MAN7EXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nowebfilters.7  | gzip -9 > $(MAN7DIR)/nowebfilters.$(MAN7EXT).gz
	rm -f $(MANDIR)/noweave.$(MANEXT).gz
	(cd $(MANDIR) && ln notangle.$(MANEXT).gz noweave.$(MANEXT).gz)
	rm -f $(MANDIR)/nountangle.$(MANEXT).gz
	(cd $(MANDIR) && ln notangle.$(MANEXT).gz nountangle.$(MANEXT).gz)
install-preformat-man:
	-echo "Warning: install-preformat-man is obsolete, even on Slackware systems" 1>&2
	mkdir -p $(CATDIR) $(CAT7DIR)
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/cpif.txt  | gzip > $(CATDIR)/cpif.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nodefs.txt  | gzip > $(CATDIR)/nodefs.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noroots.txt  | gzip > $(CATDIR)/noroots.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noweb.txt  | gzip > $(CATDIR)/noweb.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noindex.txt  | gzip > $(CATDIR)/noindex.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nuweb2noweb.txt  | gzip > $(CATDIR)/nuweb2noweb.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/notangle.txt  | gzip > $(CATDIR)/notangle.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/noroff.txt  | gzip > $(CATDIR)/noroff.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/sl2h.txt  | gzip > $(CATDIR)/sl2h.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/htmltoc.txt  | gzip > $(CATDIR)/htmltoc.$(MANEXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nowebstyle.txt  | gzip > $(CAT7DIR)/nowebstyle.$(MAN7EXT).gz
	sed -e "s@|LIBDIR|@$(LIBNAME)@" -e "s@|TEXINPUTS|@$(TEXNAME)@" xdoc/nowebfilters.txt  | gzip > $(CAT7DIR)/nowebfilters.$(MAN7EXT).gz
	rm -f $(CATDIR)/noweave.$(MANEXT).gz
	(cd $(CATDIR) && ln notangle.$(MANEXT).gz noweave.$(MANEXT).gz)
	rm -f $(CATDIR)/nountangle.$(MANEXT).gz
	(cd $(CATDIR) && ln notangle.$(MANEXT).gz nountangle.$(MANEXT).gz)
install-tex:
	mkdir -p $(TEXINPUTS)
	sed "s@|GITVERSION|@$(GITVERSION)@" tex/nwmac.tex > $(TEXINPUTS)/nwmac.tex
	sed "s@|GITVERSION|@$(GITVERSION)@" tex/noweb.sty > $(TEXINPUTS)/noweb.sty
	-texhash || echo "Program texhash not found or failed"

uninstall-tex:
	rm -f $(TEXINPUTS)/nwmac.tex
	rm -f $(TEXINPUTS)/noweb.sty
install-elisp:
	if [ "/dev/null" != "$(ELISP)" ]; then mkdir -p $(ELISP); fi
	cp elisp/noweb-mode.el $(ELISP)

uninstall-elisp:
	rm -f $(ELISP)/noweb-mode.el
source: FAQ
	for i in c shell lib xdoc icon awk tex; do (cd $$i && $(MAKE) CPIF=">" $@); done
	sleep 1
	for i in c shell lib xdoc icon awk tex; do (cd $$i && $(MAKE) touch); done
touch:
	touch FAQ
	for i in c shell lib xdoc icon awk tex; do (cd $$i && $(MAKE) $@); done
boot:
	for i in c shell lib xdoc icon awk tex; do (cd $$i && $(MAKE) $@); done
clean:
	for i in c shell lib xdoc icon awk tex; do (cd $$i && $(MAKE) $@); done
	rm -f nwsrcfilter *~ */*~

clobber: clean
	for i in c shell lib xdoc icon awk tex; do (cd $$i && $(MAKE) $@); done

Makefile: Makefile.nw
	chmod +w $@
	notangle -R'script' Makefile.nw | sh > $@
	chmod -w $@

=== contrib/conrado/Makefile ===
LIB=/dev/null  # to be overridden by install

.SUFFIXES: .nw .icn
.nw.icn:
	notangle -L'#line %-1L "%F"%N' $< | cpif $@

all: d2tex
source: d2tex
install:
	cp d2tex $(LIB)/dijkstra.filter

# TeX files.
hospital.tex: hospital.nw d2tex
	noweave -delay -filter ./d2tex hospital.nw > $@
clean:
	rm -f hospital.tex *.dvi *.aux *.log *.blg *.bbl *~

=== contrib/davelove/Makefile ===
SHELL=/bin/sh
all:
source:
install:
clean:
	rm -f *.dvi *.log *.aux

=== contrib/jobling/Makefile ===
PROG=correct-refs
SCRIPTS=list-anchors.awk awk-scripts.awk

all: correct-refs.tex correct-refs.csh $(SCRIPTS)

correct-refs.tex: correct-refs.nw
	noweave -delay -index correct-refs.nw > $@

correct-refs.csh: correct-refs.nw
	notangle -R$@ correct-refs.nw | cpif $@
	chmod +x $@

list-anchors.awk: correct-refs.nw
	notangle -R$@ correct-refs.nw | cpif $@

awk-scripts.awk: correct-refs.nw
	notangle -R$@ correct-refs.nw | cpif $@

install: correct-refs.csh $(SCRIPTS)
	cp correct-refs.csh $(HOME)/bin
	cp $(SCRIPTS) $(HOME)/lib

tidy:
	rm -f *~ *% *.bak *.log *.blg

clean: tidy
	rm -f *.ps *.dvi *.toc *.aux *.bbl *.dep $(PROG).shar

realclean: clean
	rm -f correct-refs.tex correct-refs.csh $(SCRIPTS)

shar:
	shar README Makefile $(PROG).nw > $(PROG).shar

=== contrib/jonkrom/Makefile ===
LIB=/dev/null  # override for installation
SHELL=/bin/sh
all: noxref.krom

install:
	cp noxref.krom $(LIB)

source: noxref.krom

noxref.krom: noxref.nw
	notangle -Rnoxref noxref.nw > $@
	chmod +x $@

clean:
	rm -f *.tex *.dvi *.ilg *.idx *.aux *.log *.blg *.bbl *~ *.ind noxref.krom

=== contrib/kostas/Makefile ===
# Only works with Gnu make.

LIB=/opt/noweb/lib
ICONC=icont
# This is supposed to be the defns.nw file in the icon directory of the distribution.
defns=defns.nw
TANGLE=notangle
WEAVE=noweave -delay -filter icon.filter -index

.SUFFIXES: .nw .icn .tex .dvi


all: C.filter C++.filter icon.filter oot.filter math.filter \
	autodefs.oot autodefs.math

install:
	mv *.filter $(LIB)
	mv autodefs.* $(LIB)


# TeX files.
%.tex: %.nw
	$(WEAVE) $< > $@
pp.tex: pp.nw
	noweave -delay -autodefs icon -filter icon.filter -index pp.nw > $@
%.dvi: %.tex
	latex $<
# Don't delete the intermediate .tex file.
.PRECIOUS: %.tex


# Icon files.
C.icn: pp.nw C_translation_table
	$(TANGLE) -R"C" pp.nw > $@
C++.icn: pp.nw C++_translation_table
	$(TANGLE) -R"C++" pp.nw > $@
icon.icn: pp.nw icon_translation_table
	$(TANGLE) -R"Icon" pp.nw > $@
oot.icn: pp.nw oot_translation_table
	$(TANGLE) -R"OOT" pp.nw > $@
math.icn: pp.nw math_translation_table
	$(TANGLE) -R"Mathematica" pp.nw > $@

ootdefs.icn: ootdefs.nw
	$(TANGLE) $< $(defns) > $@
mathdefs.icn: mathdefs.nw
	$(TANGLE) $< $(defns) > $@


# Executables: filters.
%.filter: %.icn
	$(ICONC) -o $@ $<

# Executables: autodefs.
autodefs.oot: ootdefs.icn
	$(ICONC) -o $@ ootdefs.icn
autodefs.math: mathdefs.icn
	$(ICONC) -o $@ mathdefs.icn


# Cleaning: remove all files that can be recreated from noweb sources.
nowebs := $(wildcard *.nw)
rem := $(nowebs:.nw=.icn)
rem := $(rem) $(nowebs:.nw=.tex)
rem := $(rem) $(nowebs:.nw=.log)
rem := $(rem) $(nowebs:.nw=.aux)
rem := $(rem) $(nowebs:.nw=.toc)


# Also remove the Icon files for the filters.
clean:
	rm -f $(rem) C.icn C++.icn icon.icn oot.icn math.icn *.filter autodefs.*

=== contrib/leew/Makefile ===
SHELL=/bin/sh
all:
install:
source:
clean:
	rm -f nocond *.dvi *.log *.aux *.toc *.tex nocond.1

=== contrib/norman/Makefile ===
LIB=/dev/null  # to be overridden
DIRS=numarkup

all:
	for i in $(DIRS); do (cd $$i && $(MAKE) $@); done
install:
	for i in $(DIRS); do (cd $$i && $(MAKE) LIB=$(LIB) $@); done
source:
	for i in $(DIRS); do (cd $$i && $(MAKE) $@); done
clean:
	for i in $(DIRS); do (cd $$i && $(MAKE) $@); done
iconlib:  # cheap hack for slackmake
	true

=== contrib/ydirson/Makefile ===
LIB=/dev/null  # to be overridden

FILTERS=guesslang inheritlang enscript-html

# nothing to tangle or weave
all:
source:
clean:

install:
	cp -p $(FILTERS) $(LIB)

=== debian/changelog ===
noweb (2.13-2) unstable; urgency=medium

  * [ce1923c] Bumped standard version - no changes needed
  * [783a3bc] Added FORCE_SOURCE_DATE=1 to build packge reproducible

 -- Mechtilde Stehmann <mechtilde@debian.org>  Sat, 19 Apr 2025 10:11:26 +0200

noweb (2.13-1) unstable; urgency=medium

  * [7d9beb5] Removed patches already integrated into upstream
  * [965811f] Removed already integrated patches from d/p/series
  * [8636376] New upstream version 2.13rc3
  * [22c1c0e] Rediff patches
  * [4c4ca28] Fixed remain string from merge confilct
  * [aeba973] New upstream version 2.13
  * [8bb93fd] Set encoding to UTF-8
  * [7b76913] Bumped compat version Bumped standard version - no changes needed
  * [666421a] Fixed versioning in d/watch
  * [821bf7f] Bumped year in d/copyright
  * [cd49bc4] Added d/u/metadata and d/salsa-ci.yml

 -- Mechtilde Stehmann <mechtilde@debian.org>  Fri, 04 Oct 2024 19:22:56 +0200

=== debian/control ===
Source: noweb
Section: devel
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Uploaders: Mechtilde Stehmann <mechtilde@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 icont,
 iconx,
 icon-ipl,
# d/rules runs dh_installtex via 'dh --with=tex':
 tex-common,
 texlive-latex-base,
 texlive-latex-extra,
Standards-Version: 4.7.2
Homepage: https://www.cs.tufts.edu/~nr/noweb
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/noweb.git
Vcs-Browser: https://salsa.debian.org/debian/noweb

Package: noweb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 gawk,
 iconx,
Recommends: texlive
Multi-Arch: foreign
Description: WEB-like literate-programming tool
 noweb is designed to meet the needs of literate programmers while
 remaining as simple as possible.  Its primary advantages are
 simplicity, extensibility, and language-independence.
 .
 The noweb manual is only 3 pages; an additional page explains how to
 customize its LaTeX output.  noweb works ``out of the box'' with any
 programming language, and supports TeX, LaTeX, and HTML back ends.
 .
 The primary sacrifice relative to WEB is that code is not
 prettyprinted.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.
#
# Modified to use dbs by Federico Di Gregorio.
# Modified to change from dbs to dpatch by Norman Ramsey

export FORCE_SOURCE_DATE=1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_CFLAGS_MAINT_APPEND := -Wall
include /usr/share/dpkg/buildflags.mk

ICONC=icont

MAKE_OPTIONS = LIBSRC=icon ICONC="${ICONC}" CFLAGS="${CFLAGS}"\
  CPPFLAGS='$(CPPFLAGS)' \
  LDFLAGS='$(LDFLAGS)' \
  BIN=/usr/bin LIB=/usr/lib/noweb \
  MAN=/usr/share/man \
  ELISP=/usr/share/emacs/site-lisp \
  TEXINPUTS=/usr/share/texmf/tex/plain/misc \
  PATH=$(PATH):$(CURDIR)/debian/bin

%:
	dh $@ --sourcedirectory=src --with=tex

patch-awk-stamp:
	cd src && ./awkname awk
	touch patch-awk-stamp

# Authors: <nr@eecs.harvard.edu>, <uhoreg@debian.org>
# Update timestamp to avoid needing noweb to build noweb

# earlier patches hit the noweb file from which these files are derived;
# by touching them, we make it possible to build noweb without already
# having noweb.
	sleep 1 # so that we have at least a second difference in timestamps
	touch \
	  src/shell/tmac.w \
	  src/shell/noweave \
	  src/shell/noroff \
	  src/shell/toroff \
	  src/tex/noweb.sty \
	  src/tex/nwmac.tex \
	  src/Makefile

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean
	if test -r patch-awk-stamp; then \
	  cd src && ./awkname nawk; \
	fi
	rm -f patch-awk-stamp
	rm -f contrib/norman/scopehack
	find . -name "*~" -name "core" -exec rm -f "{}" +

.PHONY: override_dh_auto_build
override_dh_auto_build: patch-awk-stamp
# build a version of notangle that we can use to build the man pages
	mkdir -p debian/bin
	sed "s@|LIBDIR|@$(CURDIR)/src/c@" src/shell/notangle > debian/bin/notangle
	chmod +x debian/bin/notangle

	dh_auto_build -- $(MAKE_OPTIONS)
	cd contrib/norman && $(ICONC) scopehack

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cd src/xdoc && latex guide.tex && \
	  while grep -s 'Rerun to get cross-references right' guide.log; \
	  do latex guide.tex; done && \
	  dvips guide.dvi -o guide.ps
	cd src/xdoc && latex onepage.tex && \
	  while grep -s 'Rerun to get cross-references right' onepage.log; \
	  do latex onepage.tex; done && \
	  dvips onepage.dvi -o onepage.ps
	cd src/xdoc && ../icon/sl2h guide.tex | \
	  ../icon/htmltoc >guide.html
endif

.PHONY: override_dh_installexamples
override_dh_installexamples:
# removes because is in standard tetex (and other not-needed files)
	dh_installexamples -Xmulticol.sty -Xprimes.b examples/*

.PHONY: override_dh_auto_install
override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTIONS)
# gives tmac its name and move it to right directory
	mkdir -p debian/noweb/usr/share/groff/tmac
	mv debian/noweb/usr/lib/noweb/tmac.w \
	  debian/noweb/usr/share/groff/tmac/noweb.tmac
